// grapheditDoc.cpp : implementation of the CGrapheditDoc class
//

#include "stdafx.h"
#include "graphedit.h"

#include "grapheditDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

void Node::Serialize(CArchive& ar)
{
	if(ar.IsStoring())
	{
		ar << p.x;
		ar << p.y;
	}
	else
	{
		ar >> p.x;
		ar >> p.y;
	}
}

void Arco::Serialize(CArchive& ar)
{
	if(ar.IsStoring())
	{
		ar << n[0];
		ar << n[1];
	}
	else
	{
		ar >> n[0];
		ar >> n[1];
	}
}

/////////////////////////////////////////////////////////////////////////////
// CGrapheditDoc

IMPLEMENT_DYNCREATE(CGrapheditDoc, CDocument)

BEGIN_MESSAGE_MAP(CGrapheditDoc, CDocument)
	//{{AFX_MSG_MAP(CGrapheditDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGrapheditDoc construction/destruction

CGrapheditDoc::CGrapheditDoc()
{
	// TODO: add one-time construction code here

}

CGrapheditDoc::~CGrapheditDoc()
{
}

BOOL CGrapheditDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CGrapheditDoc serialization

void CGrapheditDoc::Serialize(CArchive& ar)
{
	svector<Node>::iterator n;
	svector<Arco>::iterator a;

	if (ar.IsStoring())
	{
				ar << int(nodes.size());
		ar << int(arcs.size());
	}
	else
	{
		int ns,as;
		ar >> ns;
		ar >> as;
		nodes.resize(ns);
		arcs.resize(as);
	}
	for(n=nodes.begin();n!=nodes.end();++n)
		n->Serialize(ar);
	for(a=arcs.begin();a!=arcs.end();++a)
		a->Serialize(ar);
}

/////////////////////////////////////////////////////////////////////////////
// CGrapheditDoc diagnostics

#ifdef _DEBUG
void CGrapheditDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CGrapheditDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

inline int Dist( const CPoint & a, const CPoint & b )
{
	int dx = a.x - b.x;
	int dy = a.y - b.y;
	return dx*dx+dy*dy;
}

int CGrapheditDoc::FindNode( const CPoint & p )
{
	const int TOLL = 25;

	int mind = -1;
	int minn = -1; 
	for(int n=0;n<nodes.size();++n)
	{
		int d = Dist( p, nodes[n].p );
		if( mind==-1 || mind>d )
		{
			mind = d;
			minn = n;
		}
	}
	if(mind<=TOLL) return minn;
	else return -1;
}

/////////////////////////////////////////////////////////////////////////////
// CGrapheditDoc commands

BOOL CGrapheditDoc::OnSaveDocument(LPCTSTR lpszPathName) 
{
	return TRUE;
}
